/***************************************************************************
                          bhv_key.c  -  description
                             -------------------
    begin                : Sun Apr 6 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <malloc.h>
#include "explore.h"
#include "render.h"

static void keyStart(EX_OBJECT *pObj);
static void keyReset(EX_OBJECT *pObj);
static tObjType keyGetType(const EX_OBJECT *pObj);
static BOOL keyIsStatic(const EX_OBJECT *pObj);
static void keyDraw(const EX_OBJECT *pObj);


BOOL Bhv_Key(EX_OBJECT *pObj, const char *pParams)
{
	pObj->pGfx = TheGame.pGeneralTileGfx;
	pObj->VTable.Start = keyStart;
	pObj->VTable.Reset = keyReset;
	pObj->VTable.GetType = keyGetType;
	pObj->VTable.IsStatic = keyIsStatic;
	pObj->VTable.Draw = keyDraw;

return TRUE;
}

static void keyStart(EX_OBJECT *pObj)
{
	keyReset(pObj);
}

static void keyReset(EX_OBJECT *pObj)
{
	pObj->x = pObj->init_x;
	pObj->y = pObj->init_y;
	pObj->pBhvStateData = (void *)pObj;
}

static tObjType keyGetType(const EX_OBJECT *pObj)
{
	return eKey;
}

static BOOL keyIsStatic(const EX_OBJECT *pObj)
{
	return TRUE;
}

static void keyDraw(const EX_OBJECT *pObj)
{
	if (pObj->pBhvStateData)
		exDrawTile(pObj->pGfx, T_KEY, pObj->x, pObj->y);
}

BOOL keyIsAvailable(EX_OBJECT *pObj)
{
	if (pObj->pBhvStateData)
		return TRUE;
	else
		return FALSE;

}

void keyPickup(EX_OBJECT *pObj)
{
	pObj->pBhvStateData = NULL;
}
