/***************************************************************************
                          bhv_stilldeadly.c  -  description
                             -------------------
    begin                : Sun Apr 6 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <malloc.h>
#include "explore.h"
#include "render.h"

static void sddStart(EX_OBJECT *pObj);
static void sddReset(EX_OBJECT *pObj);
static void sddUpdate(EX_OBJECT *pObj, int frames);
static BOOL sddIsStatic(const EX_OBJECT *pObj);
static tObjType	sddGetType(const EX_OBJECT *pObj);
static void sddDraw(const EX_OBJECT *pObj);

typedef struct sSDD_STATE {
	int	iDelay;
        int     iAnimFrame;
        } EX_SDD_STATE;


BOOL Bhv_StillDeadly(EX_OBJECT *pObj, const char *pParams)
{
	pObj->pGfx = TheGame.pGeneralTileGfx;
	pObj->VTable.Start = sddStart;
	pObj->VTable.Reset = sddReset;
	pObj->VTable.Update = sddUpdate;
	pObj->VTable.Draw = sddDraw;
	pObj->VTable.IsStatic = sddIsStatic;
	pObj->VTable.GetType = sddGetType;

        pObj->pBhvStateData = malloc(sizeof(EX_SDD_STATE));
        if (!pObj->pBhvStateData)
                return FALSE;

return TRUE;
}

static void sddStart(EX_OBJECT *pObj)
{
	sddReset(pObj);
}

static void sddReset(EX_OBJECT *pObj)
{
EX_SDD_STATE *pState = pObj->pBhvStateData;

	pObj->x = pObj->init_x;
	pObj->y = pObj->init_y;
        pState->iDelay = 0;
        pState->iAnimFrame = 0;
}

static tObjType	sddGetType(const EX_OBJECT *pObj)
{
	return eDeadly;
}

static BOOL sddIsStatic(const EX_OBJECT *pObj)
{
	return TRUE;
}

static void sddUpdate(EX_OBJECT *pObj, int frames)
{
EX_SDD_STATE *pState = pObj->pBhvStateData;

	pState->iDelay += frames;

	while(pState->iDelay > 5) 
		{
		pState->iDelay -= 5;

		if (++pState->iAnimFrame == 3)
			pState->iAnimFrame = 0;
		}
}

static void sddDraw(const EX_OBJECT *pObj)
{
EX_SDD_STATE *pState = pObj->pBhvStateData;

	exDrawTile(pObj->pGfx, T_STILL_DEADLY+pState->iAnimFrame, pObj->init_x, pObj->init_y);
}

