/***************************************************************************
                          interface.c  -  description
                             -------------------
    begin                : Sat Apr 5 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "explore.h"
#include "interface.h"

void exUpdateInterface(const SDL_Event *pEvent)
{
	if (pEvent->type == SDL_KEYDOWN)
		{
		SDLKey key = pEvent->key.keysym.sym;

		if (key == SDLK_LEFT)	
			{
			TheGame.iface.iMove[EXI_MOVE_LEFT] = TRUE;
			TheGame.iface.iMove[EXI_MOVE_RIGHT] = FALSE;
			}
		if (key == SDLK_RIGHT)	
			{
			TheGame.iface.iMove[EXI_MOVE_LEFT] = FALSE;
			TheGame.iface.iMove[EXI_MOVE_RIGHT] = TRUE;
			}
		if (key == SDLK_UP)
			{
			TheGame.iface.iMove[EXI_MOVE_JUMP] = TRUE;
			}
		if (key == SDLK_DOWN)
			{
			TheGame.iface.iMove[EXI_MOVE_DOWN] = TRUE;
			}
		}

	if (pEvent->type == SDL_KEYUP)
		{
		SDLKey key = pEvent->key.keysym.sym;

		if (key == SDLK_LEFT)	
			TheGame.iface.iMove[EXI_MOVE_LEFT] = FALSE;
		if (key == SDLK_RIGHT)	
			TheGame.iface.iMove[EXI_MOVE_RIGHT] = FALSE;
		if (key == SDLK_UP)
			TheGame.iface.iMove[EXI_MOVE_JUMP] = FALSE;
		if (key == SDLK_DOWN)
			TheGame.iface.iMove[EXI_MOVE_DOWN] = FALSE;
		}

	if (pEvent->type == SDL_JOYAXISMOTION)
		{
		if (pEvent->jaxis.axis == 0)	/* X-axis; assume stick 0 */
			{
			int DeadBand = 8000;

			TheGame.iface.iMove[EXI_MOVE_LEFT] = FALSE;
			TheGame.iface.iMove[EXI_MOVE_RIGHT] = FALSE;

			if (pEvent->jaxis.value < -DeadBand)
				TheGame.iface.iMove[EXI_MOVE_LEFT] = TRUE;
			else if (pEvent->jaxis.value > DeadBand)
				TheGame.iface.iMove[EXI_MOVE_RIGHT] = TRUE;
			}
		}

	if (pEvent->type == SDL_JOYBUTTONDOWN)
		{
		if (pEvent->jbutton.button == 0)
			{
			TheGame.iface.iMove[EXI_MOVE_JUMP] = TRUE;
			TheGame.iface.iMove[EXI_MOVE_DOWN] = FALSE;
			}
		else if (pEvent->jbutton.button == 1)
			{
			TheGame.iface.iMove[EXI_MOVE_DOWN] = TRUE;
			TheGame.iface.iMove[EXI_MOVE_JUMP] = FALSE;
			}
		}

	if (pEvent->type == SDL_JOYBUTTONUP)
		{
		if (pEvent->jbutton.button == 0)
			TheGame.iface.iMove[EXI_MOVE_JUMP] = FALSE;
		if (pEvent->jbutton.button == 1)
			TheGame.iface.iMove[EXI_MOVE_DOWN] = FALSE;
		}

}	

