/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Sat Apr  5 11:51:48 BST 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include "explore.h"
#include "thegame.h"
#include "level.h"
#include "interface.h"
#include "frontend.h"


EX_GENERAL TheGame;

int main(int argc, const char *argv[])
{
SDL_Event ev;
Uint32 prev_time, curr_time;
Uint32 delta_time, period;

//	if (exInitialise(640,480, 32,24, 20,20) == FALSE)
	if (exInitialise(0, 640,480, 20,14, 32,32) == FALSE)
		return EXIT_FAILURE;

//	exShowWelcomeScreen();
	if (exLoadLevel(1) == FALSE)
		return EXIT_FAILURE;
	exStartLevel();
	
	exDrawStatic();
	exDrawDynamic();

	period = 1000/60;
	TheGame.bIsRunning = TRUE;
	prev_time = SDL_GetTicks();
	while(SDL_PollEvent(&ev) >= 0 && TheGame.bIsRunning)
		{
		if (ev.type == SDL_KEYDOWN && ev.key.keysym.sym==SDLK_F12)
			{
			static int curr_grab = 0;
			char GrabName[32];
			sprintf(GrabName, "DugPic%d.bmp", curr_grab);
			++curr_grab;
			SDL_SaveBMP(TheGame.pScreen, GrabName);
			}

		exUpdateInterface(&ev);
		do {		
			curr_time = SDL_GetTicks();
			/* Check for 49 day wrap-around */
			if (curr_time > prev_time)
				delta_time = curr_time-prev_time;
			else
				delta_time = 0xffffffff - (prev_time-curr_time) + 1;
			SDL_Delay(1);
			}
		while(SDL_PollEvent(&ev) >= 0 && delta_time < period);
		prev_time = curr_time;
		if (ev.type == SDL_QUIT)
			break;

		exRepairScreen();
		exUpdateLevel(1);
		exDrawDynamic();

		SDL_Flip(TheGame.pScreen);
		}

	exDestroyLevel();

	exShowThanksScreen();
	exRelease();

	return EXIT_SUCCESS;
}
