/***************************************************************************
                          objects.h  -  description
                             -------------------
    begin                : Sat Apr 5 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _OBJECTS_H
#define _OBJECTS_H

typedef BOOL (Bhv_Callback)(EX_OBJECT *pObj, const char *pParams);

EX_OBJECT 	*exCreateObject(Bhv_Callback *pBhv, int x, int y, const char *pConfig);

/* VTable wrappers */
void 		exStartObject(EX_OBJECT *pObj);
void 		exResetObject(EX_OBJECT *pObj);
tObjType 	exGetTypeObject(const EX_OBJECT *pObj);
BOOL 		exIsStaticObject(const EX_OBJECT *pObj);
void 		exUpdateObject(EX_OBJECT *pObj, int frames);
void 		exDrawObject(const EX_OBJECT *pObj);
void 		exDestroyObject(EX_OBJECT *pObj);

/* Behaviours */
BOOL Bhv_Player(EX_OBJECT *pObj, const char *pParams);
BOOL Bhv_DumbHorizontal(EX_OBJECT *pObj, const char *pParams);
BOOL Bhv_Key(EX_OBJECT *pObj, const char *pParams);
BOOL Bhv_FallingFloor(EX_OBJECT *pObj, const char *pParams);
BOOL Bhv_Exit(EX_OBJECT *pObj, const char *pParams);
BOOL Bhv_StillDeadly(EX_OBJECT *pObj, const char *pParams);

/* Inter-bhv communication */
BOOL keyIsAvailable(EX_OBJECT *pObj);
void keyPickup(EX_OBJECT *pObj);
void exitOpenExitGates(void);
BOOL ffDistintigrateFloor(EX_OBJECT *pObj, int frames);

#endif /* _OBJECTS_H */

