/***************************************************************************
                          render.c  -  description
                             -------------------
    begin                : Sat Apr 5 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "explore.h"
#include "render.h"
#include "level.h"

void exDrawTile(SDL_Surface *pTile, int iRegion, int x, int y)
{
SDL_Rect src, dest;
	
	src.x = (iRegion%TheGame.iNumTileWidth)*TheGame.iTileWidth;
	src.y = (iRegion/TheGame.iNumTileWidth)*TheGame.iTileHeight;
	src.w = TheGame.iTileWidth;
	src.h = TheGame.iTileHeight;

	dest.x = x;
	dest.y = y;
	dest.w = TheGame.iTileWidth;	/* Not needed, since they're ignored */
	dest.h = TheGame.iTileHeight;
	/* There is an internal 'SDL_LowerBlit' blit fn that allows stretched blitting
	** but that requires manually clipping.*/
	if (SDL_BlitSurface(pTile, &src, TheGame.pScreen, &dest) < 0)
		fprintf(stderr, "Blit error! %s", SDL_GetError());
}

void exDrawLevelTile(int tx, int ty)
{
SDL_Rect src;
EX_TILE *pTile;

	pTile = exGetTileAt(tx, ty);
	if (!pTile)	return;

	src.x = tx * TheGame.iTileWidth;
	src.y = ty * TheGame.iTileHeight;

	// Must repair area if transparencys in map
	if ((pTile->iRegion == 0 || pTile->iRegion > 4) && TheGame.curr_level.pBackdrop)		/* repair area */
		{
		src.w = TheGame.iTileWidth;
		src.h = TheGame.iTileHeight;
		SDL_BlitSurface(TheGame.curr_level.pBackdrop, &src, TheGame.pScreen, &src);
		}

	if (pTile->iRegion)
		{
		exDrawTile(TheGame.pGeneralTileGfx, pTile->iRegion, src.x, src.y);
		}

}

void exDrawArea(SDL_Surface *pTile, int x, int y, int w, int h, int dx, int dy)
{
SDL_Rect src, dest;
	
	src.x = x;
	src.y = y;
	src.w = w;
	src.h = h;

	dest.x = dx;
	dest.y = dy;
	dest.w = w;
	dest.h = h;

	if (SDL_BlitSurface(pTile, &src, TheGame.pScreen, &dest) < 0)
		fprintf(stderr, "Blit error! %s", SDL_GetError());
}

void exWriteNumber(int iScore, int iDecPlaces, int x, int y)
{
int i;

	x += iDecPlaces * TheGame.iTileWidth/2;
	for(i=0;i<iDecPlaces;i++)
		{
		x-=TheGame.iTileWidth/2;
		exDrawTile(TheGame.pGeneralTileGfx, T_NUMBERS+iScore%10, x, y);
		iScore /= 10;
		}
}

